#
# u2d7.rb
#   $Id: u2d7.rb,v 1.2 2000/11/18 19:03:46 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math


NX = 21
NY = 21
XMIN = -10
XMAX = 10
YMIN = -10
YMAX = 10
DX1 = 1
DX2 = 5
DY1 = 1
DY2 = 5
KMAX = 5
PMIN = 0
PMAX = 1
u = NArray.sfloat(NX, NY)
v = NArray.sfloat(NX, NY)
p = NArray.sfloat(NX, NY)
pi = NArray.sfloat(2, KMAX+1)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    x = XMIN + (XMAX-XMIN)*i/(NX-1).to_f
    y = YMIN + (YMAX-YMIN)*j/(NY-1).to_f
    u[i,j] =  x
    v[i,j] = -y
    p[i,j] = exp(-x**2/64 -y**2/25)
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

sglset('LSOFTF', true)
grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uxaxdv('B', DX1, DX2)
uxaxdv('T', DX1, DX2)
uxsttl('B', 'X-axis', 0.0)
uxmttl('T', 'FIGURE TITLE', 0.0)

uyaxdv('L', DY1, DY2)
uyaxdv('R', DY1, DY2)
uysttl('L', 'Y-axis', 0.0)

uglset('LUNIT', true)
ugrset('VXUOFF', 0.04)
ugsut('X', 'U')
ugsut('Y', 'V')
ugvect(u, v)

udlset('LABEL', false)
udlset('LMSG', false)
udgclb(p, 0.1)
udcntr(p)

dp = (PMAX-PMIN)/KMAX.to_f
for k in 1..KMAX
  tlev1 = (k-1)*dp
  tlev2 = tlev1 + dp
  ipat  = 600 + k - 1
  uestlv(tlev1, tlev2, ipat)
end
uetone(p)

#-- ȡС ----
grswnd(0.0, 1.0, PMIN, PMAX)
grsvpt(0.85, 0.9, 0.45, 0.75)
grstrn(1)
grstrf

for k in 1..KMAX+1
  pi[0,k-1] = PMIN + (k-1)*dp
  pi[1,k-1] = PMIN + (k-1)*dp
end

udcntr(pi)
uetone(pi)

slpvpr(3)
uzlset('LABELYR', true)
uzfact(0.8)
uysfmt('(F4.1)')
uyaxdv('R', dp, dp)

grcls
